## camitk 3.2.1

=== CMakeLists.txt ===
#--------------------------------------------
#
#         CamiTK Open Source CEP Set
#
#--------------------------------------------
cmake_minimum_required(VERSION 2.6)

project(camitkopensource)

# Specific to SDK: control the version (major, minor, default patch and )
set(CAMITK_PROJECT_NAME "CamiTK")
set(CAMITK_VERSION_MAJOR "3")
set(CAMITK_VERSION_MINOR "2")
set(CAMITK_VER_NICKNAME "azure") # blue, sapphire, *azure*, indigo, iris, Teal, cyan, turquoise, denim, celeste, zaffre, glaucous, ultramarine, cerulean
set(CAMITK_VERSION_PATCH "1") # patch version for packaging, change when appropriate
string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)

# Specific to SDK: this is the SDK build
set(CAMITK_SDK_BUILD TRUE)

#-- This is a CEP set...
set(CAMITK_EXTENSION_PROJECT_SET TRUE CACHE BOOL "Is this a CamiTK Extension Project Set?")
set(CAMITK_EXTENSION_PROJECT_SET_NAME "camitk-opensource" CACHE STRING "CEP Set Name")

# Configure CamiTK Opensource packaging.
# Must be done before parsing extensions CMakeLists.txt files.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros)
include(CamiTKOpenSourcePackaging)
camitk_opensource_packaging()

# Specific to SDK: first compile the SDK (it looks like a CEP but is sooooo special...)
add_subdirectory(sdk)

# ...composed by the following CamiTK Extension Projects
add_subdirectory(imaging)
add_subdirectory(modeling)

camitk_sub_project_validate(CEP_SET)

=== imaging/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro apropriately

# Inform the user he has the choice of the DICOM component, by default uses the incomplete ITK one
# Complete dicomdirectory and dicomimage ones require GDCM library
option(CAMITK_DICOM_INCOMPLETE_SUPPORT "Use incomplete support of DICOM images via ITK" TRUE)

if (NOT CAMITK_DICOM_INCOMPLETE_SUPPORT)
    add_subdirectory(dicomdirectory)
    add_subdirectory(dicomimage)
else()
    message(WARNING "Using old component dicom (using ITK), prefer using dicomdirectory and dicomimage components (which require GDCM library)")
    add_subdirectory(dicom)
endif() 

# TODO restore when dicom component would have been replaced by new ones (using GDCM)
# find components
# get_subdirectories(COMPONENTS_LIST)

# Add subdirectories in CMake project
# foreach(COMPONENT_NAME ${COMPONENTS_LIST})
#   add_subdirectory(${COMPONENT_NAME})
# endforeach()

add_subdirectory(itkimage)

=== imaging/actions/itkfilters/CMakeLists.txt ===
camitk_extension(
                    ACTION_EXTENSION
                    NEEDS_ITK
                    LIBRARIES ITKBasicFilters ITKCommon ITKIO
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This action features basic ITK image processing filters"
)

=== imaging/components/dicom/CMakeLists.txt ===
# dicom component just needs to use the component_extension macro
camitk_extension(   COMPONENT_EXTENSION
                    NEEDS_ITK
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION  "This component allows the handling of DICOM images using GDCM 2.2"
)

=== imaging/components/itkimage/CMakeLists.txt ===
# itkimage component just needs to use the component_extension macro
camitk_extension(   COMPONENT_EXTENSION 
                    NEEDS_ITK 
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This component allows CamiTK to handle basic ITK format images."
)

=== modeling/libraries/qcustomplot/CMakeLists.txt ===
project(qcustomplot)

cmake_minimum_required(VERSION 2.6)

if (PACKAGING_NSIS)
    set(LIB_NAME library_qcustomplot)
else()
    set(LIB_NAME library-qcustomplot)
endif()

# Qt is required
find_package(Qt4 REQUIRED)
include(${QT_USE_FILE})

#headers
set(CUSTOM_PLOT_HEADERS 
  qcustomplot.h
  QCustomPlotAPI.h
)

# Qt headers
set(CUSTOM_PLOT_QT_HEADERS 
  qcustomplot.h
)

QT4_WRAP_CPP(CUSTOM_PLOT_QT_HEADERS_MOC ${CUSTOM_PLOT_QT_HEADERS})

# sources files
set(CUSTOM_PLOT_SOURCES
  qcustomplot.cpp
  ${CUSTOM_PLOT_HEADERS}
  ${CUSTOM_PLOT_QT_HEADERS_MOC}
)

add_definitions(-DCOMPILE_QCUSTOMPLOT)

# take all the headers for installation
file(GLOB HEADERS_H "src/*.h")
file(GLOB HEADERS_UPPERCASE "src/Qt*")

# add lib as a camitk tool
camitk_library(SHARED
               SOURCES ${CUSTOM_PLOT_SOURCES}
               TARGET_LINK_LIBRARIES ${QT_LIBRARIES}
               INCLUDE_DIRECTORIES ${QT_INCLUDE_DIR}
               HEADERS_TO_INSTALL ${CUSTOM_PLOT_HEADERS}
               CEP_NAME CEP_MODELING
               DESCRIPTION "Tool to draw dots (plots) in a Qt interface."
)

=== sdk/applications/config/CMakeLists.txt ===
camitk_application( ADDITIONAL_SOURCES CommandLineOptions.cxx CommandLineOptions.hxx CommandLineOptions.ixx
                    CEP_NAME SDK
                    DESCRIPTION "Provides information on your installation of CamiTK"
)

if(APPLICATION_CONFIG)
    # prepare the CamiTKConfig.cmake for installation
    install(CODE "message(STATUS \"Updating CamiTKDir.txt in User Config Directory (${CAMITK_USER_DIR}) to ${CMAKE_INSTALL_PREFIX} \")")
    install(CODE "configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CamiTKDir.txt.in ${CMAKE_BINARY_DIR}/CamiTKDir.txt @ONLY)")
endif()

=== modeling/libraries/mml/applications/CMakeLists.txt ===
# generation benchmark binary is optionnal

if(MML_GENERATE_GUI)
  find_package(Qt4 REQUIRED)
  add_definitions(-DMML_GENERATE_GUI)
  add_subdirectory(gui)
endif()

option(MML_GENERATE_BENCHMARK "Generates benchmark binary" OFF)
if(MML_GENERATE_BENCHMARK)
  add_subdirectory(benchmark)
endif()

if(MML_SOFA_SUPPORT)
    option(MML_GENERATE_SCN2PML "Generates scn2pml binary" OFF)
    if(MML_GENERATE_SCN2PML)
    add_subdirectory(scn2pml)
    endif()
endif()

option(MML_GENERATE_PML2MMLOUT "Generates pml2mmlOut binary" OFF)
if(MML_GENERATE_PML2MMLOUT)
  add_subdirectory(pml2mmlOut)
endif()

option(MML_GENERATE_PARAMEXPLORER "Generates paramExplorer binary" OFF)
if(MML_GENERATE_PARAMEXPLORER)
  add_subdirectory(paramExplorer)
endif()

option(MML_GENERATE_MML2CSV "Generates mml2Csv binary" OFF)
if(MML_GENERATE_MML2CSV)
  add_subdirectory(convertMml/mml2Csv)
endif()

option(MML_GENERATE_CSV2STATSVAL "Generates csv2StatsVal binary" OFF)
if(MML_GENERATE_CSV2STATSVAL)
  add_subdirectory(convertMml/csv2Sthing/csv2StatsVal)
endif()

option(MML_GENERATE_CSV2PLOT "Generates csv2Plot binary" OFF)
if(MML_GENERATE_CSV2PLOT)
  set (TOOL_QCUSTOMPLOT ON CACHE BOOL "required for convertMMlGui" FORCE)
  add_subdirectory(convertMml/csv2Sthing/csv2Plot)
endif()

option(MML_GENERATE_CONVERTMMLGUI "Generates convertMmlGui binary" OFF)
if(MML_GENERATE_CONVERTMMLGUI)
  set (TOOL_QCUSTOMPLOT ON CACHE BOOL "required for convertMMlGui" FORCE)
  set (MML_GENERATE_CSV2PLOT ON CACHE BOOL "required for convertMMlGui" FORCE)
  set (MML_GENERATE_CSV2STATSVAL ON CACHE BOOL "required for convertMMlGui" FORCE)
  set (MML_GENERATE_MML2CSV ON CACHE BOOL "required for convertMMlGui" FORCE)
  add_subdirectory(convertMml/convertMmlGui)
endif()

# TODO Find(sofa)...
if(MML_SOFA_SUPPORT)
  if(WIN32)
    set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/win32 ${MML_SOFA_DIR}/lib)
  else(WIN32)
    set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/linux ${MML_SOFA_DIR}/lib)
  endif(WIN32)
  set(MML_bin_link ${MML_bin_link} ${MML_SOFA_LIB_DIR})
endif(MML_SOFA_SUPPORT)


link_directories(${MML_bin_link})

=== modeling/libraries/mml/monitoring/CMakeLists.txt ===
project(monitoring)

if (PACKAGING_NSIS)
    set(LIB_NAME library_monitoring)
else()
    set(LIB_NAME library-monitoring)
endif()

# TODO properly define the path to the XML Schema at run time (in MonitoringManager and MonitoringManagerFactory)
# otherwise this generates an error when executing the application on a machine that have no or a different
# source dir path!
#add_definitions(-DMONITORIN_XSD="${CMAKE_CURRENT_SOURCE_DIR}/../schema/MonitorIn.xsd")
#add_definitions(-DMONITOROUT_XSD="${CMAKE_CURRENT_SOURCE_DIR}/../schema/MonitorOut.xsd")

option(MML_GENERATE_GUI "Generates MML GUI for CamiTK action" ON)
if(MML_GENERATE_GUI)
  find_package(Qt4 REQUIRED)
  include(${QT_USE_FILE})
  add_definitions(-DMML_GENERATE_GUI)
endif(MML_GENERATE_GUI)

# "find" SOFA (you need to have a SOFA_DIR environment variable
# or to define it manually during configuration process)
set(MML_SOFA_DIR $ENV{MML_SOFA_DIR} CACHE PATH "Where to find SOFA")
if(EXISTS ${MML_SOFA_DIR})
  # Compile Sofa .scn import filter? (ON or OFF)
  option(MML_SOFA_SUPPORT "Compile Sofa Simulator?" ON)
endif(EXISTS ${MML_SOFA_DIR})

# sofa settings
if(MML_SOFA_SUPPORT)
  option(MML_SOFA_1_0_RC1 "Set to ON (default) if Sofa 1.0 RC1 is available in ${MML_SOFA_DIR}" ON)
  if(MML_SOFA_1_0_RC1)
    add_definitions(-DSOFA_1_0_RC1)
  endif()
  # compilation flag
  add_definitions(-DSOFA_SUPPORT)
  add_definitions(-DSOFA_PATH="${MML_SOFA_DIR}")
  # library settings
  if(WIN32)
    set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/win32/ReleaseVC9 ${MML_SOFA_DIR}/lib/win32 ${MML_SOFA_DIR}/lib ${MML_SOFA_DIR}/bin )
  else(WIN32)
    set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/linux ${MML_SOFA_DIR}/lib)
  endif(WIN32)
  if(NOT MML_SOFA_1_0_RC1)
    # Sofa1.0 from svn branch
    set(MML_SOFA_LIBS sofacore sofacomponent sofasimulation sofatree sofahelper sofadefaulttype)
  else()
    set(MML_SOFA_LIBS sofacore #sofa_component_dev
    #sofa_component_advanced_dev sofa_component_misc_dev
    sofa_component
    #sofa_non_uniform_fem_dev
    #sofa_advanced_fem 
    #sofa_mjed_fem 
    #sofa_advanced_constraint 
    #sofa_advanced_interaction 
    #sofa_misc_topology_dev 
    #sofa_misc_mapping_dev 
    #sofa_misc_forcefield_dev 
    #sofa_misc_fem_dev 
    #sofa_misc_collision_dev 
    #sofa_misc_solver_dev 
    #sofa_misc_dev
    sofa_exporter sofa_loader sofa_misc_forcefield sofa_component_base sofa_component_common sofa_component_general sofa_component_advanced sofa_component_misc sofahelper sofa_engine sofa_sph_fluid sofa_non_uniform_fem sofa_base_topology sofa_boundary_condition sofa_haptics sofa_constraint sofatree sofa_base_linear_solver sofa_implicit_ode_solver sofa_simple_fem sofa_topology_mapping sofa_user_interaction sofa_misc_collision sofa_preconditioner sofa_misc_topology sofa_mesh_collision sofa_volumetric_data 
    #sofabgl 
    sofa_base_collision sofa_deformable sofa_graph_component sofa_base_mechanics sofa_rigid sofa_base_animation_loop sofa_object_interaction sofa_explicit_ode_solver sofa_eigen2_solver sofa_validation sofa_dense_solver sofa_eulerian_fluid sofa_misc_mapping sofa_misc_fem sofa_misc_engine sofa_misc_solver sofa_misc
    sofa_base_visual #-lnewmat -lGLEW -lpng
        sofasimulation #-lminiFlowVR
        sofacore #-ltinyxml
        sofadefaulttype #-lQt3Support -lQtOpenGL -lQtGui -lQtCore -lGLU -lGL -lpthread
            sofamodeler
    )
  endif()
  # add debug suffix
  if(WIN32)
        if( CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo" )
            set(MML_SOFA_LIBS_WIN32 ${MML_SOFA_LIBS})
            set(MML_SOFA_LIBS)
            if(MML_SOFA_1_0_RC1)
                set(SOFA_VERSION_SUFFIX "_1_0d")
            else()
                set(SOFA_VERSION_SUFFIX "d")
            endif()
            foreach(SOFA_LIB ${MML_SOFA_LIBS_WIN32})
                    set(MML_SOFA_LIBS ${MML_SOFA_LIBS} ${SOFA_LIB}${SOFA_VERSION_SUFFIX})
            endforeach()
        endif()
  endif()
  # includes
  set(MML_SOFA_INCLUDE_DIR ${MML_SOFA_DIR}/include ${MML_SOFA_DIR}/modules ${MML_SOFA_DIR}/framework
    ${MML_SOFA_DIR}/extlibs/miniBoost ${MML_SOFA_DIR}/include/modules
    ${MML_SOFA_DIR}/include/framework ${MML_SOFA_DIR}/include/extlibs/miniBoost )
  if(MML_GENERATE_GUI)
    set(sofa_MOC_SRCS
    simulator/simulators/Sofa/SofaWidget.h
    )

    set(sofa_UIS
        simulator/simulators/Sofa/SofaWidget.ui
    )
    
    qt4_wrap_ui(sofa_UIS_H ${sofa_UIS})
    qt4_wrap_cpp(sofa_MOCS ${sofa_MOC_SRCS})
    set(sofa_QT_SRC
      simulator/simulators/Sofa/SofaWidget.cpp
    )
  endif(MML_GENERATE_GUI)
  set(MML_SOFA_HEADERS
    simulator/simulators/Sofa/SofaSimulator.h
    simulator/simulators/Sofa/TranslationConstraint.h
    ${sofa_UIS_H}
    ${sofa_MOC_SRCS}
  )
  set(MML_SOFA_SRC
    simulator/simulators/Sofa/SofaSimulator.cpp
    simulator/simulators/Sofa/TranslationConstraint.cpp
    simulator/simulators/Sofa/TranslationConstraint.inl
    ${sofa_MOCS}
    ${sofa_MOC_UI}
    ${sofa_QT_SRC}
  )
endif(MML_SOFA_SUPPORT)


set(MML_ANSYS_BIN $ENV{MML_ANSYS_BIN} CACHE FILE "Where to find Ansys binary")
set(MML_ANSYS_WORKING_DIR $ENV{MML_ANSYS_WORKING_DIR} CACHE PATH "Specify a folder for ansys working files")
if(EXISTS ${MML_ANSYS_BIN})
if(EXISTS ${MML_ANSYS_WORKING_DIR})
  # Compile Ansys simulator files (ON or OFF)
  option(MML_ANSYS_SUPPORT "Compile Ansys simulator?" ON)

  # ansys settings
  if(MML_ANSYS_SUPPORT)
    # compilation flag
    add_definitions(-DANSYS_SUPPORT)
    add_definitions(-DANSYS_BIN="${MML_ANSYS_BIN}" -DANSYS_WORKING_DIR="${MML_ANSYS_WORKING_DIR}")
    
    if(MML_GENERATE_GUI)
    set(ansys_MOC_SRCS
    simulator/simulators/Ansys/AnsysWidget.h
    )

    set(ansys_UIS
        simulator/simulators/Ansys/AnsysWidget.ui
    )
    
    qt4_wrap_ui(ansys_UIS_H ${ansys_UIS})
    qt4_wrap_cpp(ansys_MOC_UI ${ansys_UIS_H})
    qt4_wrap_cpp(ansys_MOCS ${ansys_MOC_SRCS})
    set(ansys_QT_SRC
      simulator/simulators/Ansys/AnsysWidget.cpp
    )
    endif(MML_GENERATE_GUI)

    set(MML_ANSYS_HEADERS
      simulator/simulators/Ansys/AnsysBatch.h
      simulator/simulators/Ansys/AnsysBatchWriter.h
      simulator/simulators/Ansys/AnsysBatchWriters/PrepWriter.h
      simulator/simulators/Ansys/AnsysBatchWriters/SoluWriter.h
      simulator/simulators/Ansys/AnsysBatchWriters/PostWriter.h
      simulator/simulators/Ansys/AnsysBatchWriters/ParametersWriter.h
      simulator/simulators/Ansys/AnsysSimulator.h
      ${ansys_UIS_H}
      ${ansys_MOC_SRCS}
    )
    set(MML_ANSYS_SRC
      simulator/simulators/Ansys/AnsysBatch.cpp
      simulator/simulators/Ansys/AnsysBatchWriter.cpp
      simulator/simulators/Ansys/AnsysBatchWriters/PrepWriter.cpp
      simulator/simulators/Ansys/AnsysBatchWriters/SoluWriter.cpp
      simulator/simulators/Ansys/AnsysBatchWriters/PostWriter.cpp
      simulator/simulators/Ansys/AnsysBatchWriters/ParametersWriter.cpp
      simulator/simulators/Ansys/AnsysSimulator.cpp
      ${ansys_MOCS}
      ${ansys_MOC_UI}
      ${ansys_QT_SRC}
    )
  endif(MML_ANSYS_SUPPORT)
endif(EXISTS ${MML_ANSYS_WORKING_DIR})
endif(EXISTS ${MML_ANSYS_BIN})

set(MML_ARTISYNTH_BIN $ENV{MML_ARTISYNTH_BIN} CACHE FILE "Where to find artisynth binary")
set(MML_ARTISYNTH_WORKING_DIR $ENV{MML_ARTISYNTH_WORKING_DIR} CACHE PATH "Specify a folder for artisynth working files")
if(EXISTS ${MML_ARTISYNTH_BIN})
if(EXISTS ${MML_ARTISYNTH_WORKING_DIR})
  # Compile ARTISYNTH simulator files (ON or OFF)
  option(MML_ARTISYNTH_SUPPORT "Compile Artisynth simulator?" ON)

  # ARTISYNTH settings
  if(MML_ARTISYNTH_SUPPORT)
    # compilation flag
    add_definitions(-DARTISYNTH_SUPPORT)
    add_definitions(-DARTISYNTH_BIN="${MML_ARTISYNTH_BIN}" -DARTISYNTH_WORKING_DIR="${MML_ARTISYNTH_WORKING_DIR}")
    set(MML_ARTISYNTH_HEADERS
      simulator/simulators/ArtiSynth/ArtiSynthSimulator.h
    )
    set(MML_ARTISYNTH_SRC
      simulator/simulators/ArtiSynth/ArtiSynthSimulator.cpp
    )
  endif(MML_ARTISYNTH_SUPPORT)
endif(EXISTS ${MML_ARTISYNTH_WORKING_DIR})
endif(EXISTS ${MML_ARTISYNTH_BIN})

if(MML_GENERATE_GUI)
    set(MML_MOC_SRCS
    simulator/SimulatorWidget.h
    tools/Xmlhighlighter.h
    )
  qt4_wrap_cpp(MML_MOCS ${MML_MOC_SRCS})
  set(MML_QT_SRC
      simulator/SimulatorWidget.cpp
      tools/Xmlhighlighter.cpp
    )
endif(MML_GENERATE_GUI)

set(monitoring_H
  MMLAPI.h
  stoppingCriterion/StoppingCriterion.h
  stoppingCriterion/StoppingCriterionFactory.h
  stoppingCriterion/stoppingCriteria/Criterion.h
  stoppingCriterion/stoppingCriteria/CriterionFactory.h
  stoppingCriterion/stoppingCriteria/MultipleCriterion.h
  stoppingCriterion/stoppingCriteria/MultipleCriterionFactory.h
  stoppingCriterion/stoppingCriteria/Method.h
  stoppingCriterion/stoppingCriteria/MethodFactory.h
  stoppingCriterion/stoppingCriteria/criteria/Force.h 
  stoppingCriterion/stoppingCriteria/criteria/KineticEnergy.h
  stoppingCriterion/stoppingCriteria/criteria/Position.h
  stoppingCriterion/stoppingCriteria/criteria/Time.h
  stoppingCriterion/stoppingCriteria/criteria/Velocity.h
  stoppingCriterion/stoppingCriteria/multipleCriteria/AndMultipleCriterion.h
  stoppingCriterion/stoppingCriteria/multipleCriteria/OrMultipleCriterion.h
  stoppingCriterion/stoppingCriteria/methods/MinThreshold.h
  stoppingCriterion/stoppingCriteria/methods/Threshold.h
  simulator/Simulator.h
  simulator/NonInteractiveSimulator.h
  simulator/InteractiveSimulator.h
  simulator/SimulatorFactory.h
  simulator/simulators/InitSimulators.h
  ${MML_SOFA_HEADERS}
  ${MML_ANSYS_HEADERS}
  ${MML_ARTISYNTH_HEADERS}
  ${MML_MOC_SRCS}
  monitor/Monitor.h 
  monitor/MonitorFactory.h
  monitor/monitors/MonitorGeometricDeviation.h
  monitor/monitors/MonitorPosition.h
  monitor/monitors/MonitorRen.h
  monitor/monitors/MonitorForce.h
  monitor/monitors/MonitorPointSetDistance.h
  monitor/monitors/MonitorPointFinalSetDistance.h
  monitor/monitors/MonitorVolume.h
  monitor/monitors/MonitorSurface.h
  monitor/monitors/MonitorDisplacement.h
  monitor/monitors/MonitorNormDisplacement.h
  monitor/monitors/MonitorPointToTriangleMeshDistanceFinal.h
  monitor/monitors/MonitorDistanceX.h
  monitor/monitors/MonitorDistanceY.h
  monitor/monitors/MonitorDistanceZ.h
  monitor/monitors/MonitorComputingTime.h
  reference/Reference.h
  tools/Chrono.h
  tools/Tools.h
  tools/Macros.h
  tools/AtomIterator.h
  tools/SurfaceExtractor/Facet.h
  tools/SurfaceExtractor/SurfaceExtractor.h
  manager/MonitoringManager.h
  manager/MonitoringManagerFactory.h
  manager/InteractiveMonitoringManager.h
  manager/NonInteractiveMonitoringManager.h
)

set(monitoring_SRCS
  ${monitoring_H}
  stoppingCriterion/StoppingCriterion.cpp
  stoppingCriterion/StoppingCriterionFactory.cpp
  stoppingCriterion/stoppingCriteria/Criterion.cpp
  stoppingCriterion/stoppingCriteria/CriterionFactory.cpp
  stoppingCriterion/stoppingCriteria/MultipleCriterion.cpp
  stoppingCriterion/stoppingCriteria/MultipleCriterionFactory.cpp
  stoppingCriterion/stoppingCriteria/Method.cpp
  stoppingCriterion/stoppingCriteria/MethodFactory.cpp
  stoppingCriterion/stoppingCriteria/criteria/Force.cpp 
  stoppingCriterion/stoppingCriteria/criteria/KineticEnergy.cpp
  stoppingCriterion/stoppingCriteria/criteria/Position.cpp
  stoppingCriterion/stoppingCriteria/criteria/Time.cpp
  stoppingCriterion/stoppingCriteria/criteria/Velocity.cpp
  stoppingCriterion/stoppingCriteria/multipleCriteria/AndMultipleCriterion.cpp
  stoppingCriterion/stoppingCriteria/multipleCriteria/OrMultipleCriterion.cpp
  stoppingCriterion/stoppingCriteria/methods/MinThreshold.cpp
  stoppingCriterion/stoppingCriteria/methods/Threshold.cpp
  simulator/Simulator.cpp
  simulator/NonInteractiveSimulator.cpp
  simulator/InteractiveSimulator.cpp
  simulator/SimulatorFactory.cpp
  ${MML_SOFA_SRC}
  ${MML_ANSYS_SRC}
  ${MML_ARTISYNTH_SRC}
  ${MML_MOCS}
  ${MML_QT_SRC}
  monitor/Monitor.cpp
  monitor/MonitorFactory.cpp
  monitor/monitors/MonitorGeometricDeviation.cpp
  monitor/monitors/MonitorPosition.cpp
  monitor/monitors/MonitorRen.cpp
  monitor/monitors/MonitorForce.cpp

=== sdk/actions/mesh/meshprocessing/CMakeLists.txt ===
camitk_extension(   ACTION_EXTENSION
                    NEEDS_COMPONENT_EXTENSION vtkmesh
                    DEFINES COMPILE_MESHPROCESSING_ACTION_API
                    CEP_NAME SDK
                    DESCRIPTION "Features some nice algorithms to process on meshes"
                )

=== modeling/libraries/mml/applications/convertMml/convertMmlGui/CMakeLists.txt ===
project(convertMmlGui)

cmake_minimum_required(VERSION 2.6)

find_package(Qt4 REQUIRED)
include(${QT_USE_FILE})

# qcustomplot is required
set(TOOL_QCUSTOMPLOT TRUE CACHE BOOL "Required by tool convertMmlGUI" FORCE )

include_directories(    ${CMAKE_CURRENT_SOURCE_DIR}
                        ${CMAKE_CURRENT_BINARY_DIR}
                        ${CAMITK_INCLUDE_DIR}
                        ${CAMITK_INCLUDE_DIR}/libraries/mml
                        ${CAMITK_INCLUDE_DIR}/libraries/qcustomplot)

set(convertMmlGui_LIBRARIES
  ${QT_LIBRARIES}
)

set(CONVERTMMLGUI_MOC_SRCS
    convertMml.h
    help.h
    ../csv2Sthing/csv2Plot/plotWindow.h
)

set(CONVERTMMLGUI_UIS
    convertMml.ui
    help.ui
    ../csv2Sthing/csv2Plot/plotWindow.ui
)

set(CONVERTMMLGUI_RCC_SRCS
    convertMml.qrc)

qt4_wrap_ui(CONVERTMMLGUI_UIS_H ${CONVERTMMLGUI_UIS})
qt4_wrap_cpp(CONVERTMMLGUI_MOCS ${CONVERTMMLGUI_MOC_SRCS})
qt4_add_resources(CONVERTMMLGUI_RCC ${CONVERTMMLGUI_RCC_SRCS})


set(HEADERS
	    ../csv2Sthing/csv2StatsVal/csv2StatsVal.h
	    ../csv2Sthing/csv2Sthing.h
	    ../mml2Csv/mml2Csv.h
	    ../mml2Csv/dataMonitoredList.h
	    ../csv2Sthing/csv2Plot/csv2Plot.h
	    ${CONVERTMMLGUI_UIS_H}
    )

set(SRCS
	    convertMml.cpp
	    help.cpp
	    ../csv2Sthing/csv2StatsVal/csv2StatsVal.cpp
	    ../csv2Sthing/csv2Plot/plotWindow.cpp
	    ../csv2Sthing/csv2Sthing.cpp
	    ../mml2Csv/mml2Csv.cpp
	    ../mml2Csv/dataMonitoredList.cpp
	    ../csv2Sthing/csv2Plot/csv2Plot.cpp
	    ${HEADERS}
	    ${CONVERTMMLGUI_MOCS}
	    ${CONVERTMMLGUI_MOC_UI}
	    ${CONVERTMMLGUI_RCC}
    )


add_library(convertMmlguigui STATIC ${SRCS})

link_directories(${gui_link})

add_executable(convertMmlGui ${SRCS})

target_link_libraries(convertMmlGui library-monitoring library-qcustomplot ${convertMmlGui_LIBRARIES})

add_custom_target(convertMmlGuiBin ALL)

add_dependencies(convertMmlGui library-monitoring library-qcustomplot)

=== modeling/libraries/mml/applications/convertMml/mml2Csv/CMakeLists.txt ===
project(mml2Csv)

cmake_minimum_required(VERSION 2.6)



include_directories(    ${CMAKE_CURRENT_SOURCE_DIR}
                        ${CMAKE_CURRENT_BINARY_DIR}
                        ${CAMITK_INCLUDE_DIR}
                        ${CAMITK_INCLUDE_DIR}/libraries/mml
                        ${CAMITK_INCLUDE_DIR}/libraries/monitoring
                        ${MML_INCLUDE_DIRECTORIES}
            )

set(mml2Csv_LIBRARIES
  ${MML_LIBRARIES} #for xerces and libxml2
)

set(HEADERS
  mml2Csv.h
  dataMonitoredList.h
)

set(SRCS
  mml2Csv.cpp
  dataMonitoredList.cpp
  main.cpp
  ${HEADERS}
)

link_directories(${mml2Csv_link})

add_executable(mml2Csv ${SRCS})

target_link_libraries(mml2Csv ${mml2Csv_LIBRARIES} library-monitoring)

add_custom_target(mml2CsvBin ALL)

add_dependencies(mml2Csv library-monitoring)

=== debian/changelog ===
camitk (3.2.1-1) unstable; urgency=low

  [ Emmanuel Promayon ]
  * New upstream release.
    - Update STL obsolete code. Closes: #701250
  * New package for camitk actionstatemachine
  * Updated debian/watch (web site change)
  * Updated debian/copyright due to new source organization in upstream
  * Updated debian/control due to new source organization in upstream
  * Patches:
    - desktop file (camitk-imp-categories.diff)
    - clean version id (remove-svn-revision.diff)
    - force dlopen path to load unfound library 
      (load-private-lib-if-needed.diff)
    - use install path to share directory, needed when data are not installed
      (wizard-copy-proper-findcamitk.diff)
  * XPM icon

  [ Andreas Tille ]
  * debian/rules:
     - get-orig-source: create download dir if needed
     - Use xz compression

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Tue, 02 Jul 2013 09:25:22 +0200

=== debian/control ===
Source: camitk
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>, Emmanuel Promayon <Emmanuel.Promayon@imag.fr>
Build-Depends: debhelper (>= 9), cmake (>= 2.6), libvtk5-dev (>= 5.8), libqt4-dev (>= 4.7), libvtk5-qt4-dev (>= 5.8), xsdcxx (>= 3.2), libinsighttoolkit3-dev (>= 3.20), libxerces-c-dev (>= 3.1), libxml2-dev (>= 2.7), libgdcm2-dev (>= 2.0), libfftw3-dev, libqtwebkit-dev | libqt4-dev (<< 4.7), libvtkgdcm2-dev (>= 2.0), tcl-vtk, python-vtk, libvtk-java
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 3.9.4
Homepage: http://camitk.imag.fr/
X-Homepage: https://forge.imag.fr/projects/camitk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/camitk/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/camitk/trunk/

Package: libcamitk3
Architecture: any
Depends: libqtpropertybrowser3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: libcamitk3-dev
Architecture: any
Section: libdevel
Depends: libcamitk3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard to create new extensions.

Package: libcamitk3-data
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the example and test data for CamiTK.

Package: libcamitk3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: flagship application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-imp is the CamiTK workbench application where you can test
 all available extensions for prototyping.
 It provides an easy and interactive access to all available data and
 algorithm parameters, including the one you build yourself using
 the CamiTK SDK.
 .
 For example, camitk-imp can visualize medical images from a lot of different
 (standard) formats, offers image processing and segmentation algorithms to
 reconstruct a mesh geometry and run a biomechanical simulation.

Package: camitk-actionstatemachine
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: flagship application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-actionstatemachine is able to replay a pipeline (workflow) of CamiTK 
 actions.
 This application takes an CamiTK augmented version of a SCXML subset as input
 and allow to replay interactive the described state-machine containing a list
 of CamiTK actions and transitions.

Package: libqtpropertybrowser3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt Property Browser Library - runtime
 A framework providing a set of graphical editors for 
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains the shared libraries needed to run applications
 linked against libqtpropertybrowser3.

Package: libqtpropertybrowser3-dev
Architecture: any
Section: libdevel
Depends: libqtpropertybrowser3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Qt Property Browser Library - development
 A framework providing a set of graphical editors for 
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains development files needed to build applications
 using Qt Property Browser

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# CamiTK version
VER_MAJOR=3
VER_MINOR=2
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

# package aliases (see d/control)
pkg_lib = libcamitk$(VER_MAJOR)
pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
pkg_dev = libcamitk$(VER_MAJOR)-dev
pkg_qpb_dev = libqtpropertybrowser$(VER_MAJOR)-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp
pkg_asm = camitk-actionstatemachine

# dpkg-shlibdeps needs to know about camitk extension directories to manage inner-dependencies
# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
# for component extensions:
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/components/
# for action extensions: 
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/actions/
# for private libraries:
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/

# CMake flags are of two types:
# - generic (to tell cmake to build proper binaries)
# - CamiTK specific options
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	\
	-DCEP_IMAGING:BOOL=TRUE \
	-DCEP_MODELING:BOOL=TRUE \
	\
	-DAPIDOC_SDK:BOOL=TRUE \
	\
	-DCAMITK_DICOM_INCOMPLETE_SUPPORT:BOOL=ON 

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# let's be smart with doc
override_dh_auto_build-indep:
	$(MAKE) -C obj-* apidoc
	# remove the javascript search field
	rm -f obj-*/share/camitk-$(VER_SHORT)/apidoc/html/jquery.js

# No tests needed for docs
override_dh_auto_test-indep:

override_dh_install:
	# $(CURDIR) is the current source dir
	# camitk dynamic library
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/libcamitkcore.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/bin/camitk-config
	dh_install -p$(pkg_lib) debian/camitk.xpm usr/share/pixmaps
	dh_installman -p$(pkg_lib) debian/tmp/usr/share/man/man1/camitk-config.1  

	# separate tools qtpropertybrowser
	dh_install -p$(pkg_qpb) debian/tmp/usr/lib/libqtpropertybrowser.so.* usr/lib

	# camitk so and headers and static libs + wizard
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libcamitkcore.so usr/lib 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/camitkcore
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/coreschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/actions
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/components
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/pml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/lml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/mml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoring
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoringgui
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/*.cmake 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/launcher-templates/*.in
	dh_install -p$(pkg_dev) debian/tmp/usr/bin/camitk-wizard
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1

        # qtpropertybrowser so and headers (includes are put directly in usr/include as package should be generic/independant from CamiTK)
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/lib/libqtpropertybrowser.so usr/lib
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/qtpropertybrowser usr/include

	# api doc
	dh_install -p$(pkg_doc) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/apidoc

	# all test data
	dh_install -p$(pkg_data) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/testdata

	# imp
	dh_install -p$(pkg_imp) debian/tmp/usr/bin/camitk-imp
	dh_install -p$(pkg_imp) debian/tmp/usr/share/applications/camitk-imp.desktop
	dh_installman -p$(pkg_imp) debian/tmp/usr/share/man/man1/camitk-imp.1

	# asm
	dh_install -p$(pkg_asm) debian/tmp/usr/bin/camitk-actionstatemachine
	dh_installman -p$(pkg_asm) debian/tmp/usr/share/man/man1/camitk-actionstatemachine.1

override_dh_builddeb:
	dh_builddeb -- -Z xz

# see http://lists.debian.org/debian-mentors/2012/07/msg00124.html
get-orig-source:
	mkdir -p ../tarballs
	PERL_LWP_SSL_VERIFY_HOSTNAME=0 uscan --rename --verbose --force-download --destdir=../tarballs
